VERSION 5.00
Begin VB.Form frmDemoSave 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Save demo"
   ClientHeight    =   1755
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5475
   ControlBox      =   0   'False
   Icon            =   "frmDemoSave.frx":0000
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1755
   ScaleWidth      =   5475
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox txtDemoFile 
      Height          =   315
      Left            =   120
      TabIndex        =   4
      Top             =   420
      Width           =   5175
   End
   Begin VB.CommandButton cmdDiscard 
      Cancel          =   -1  'True
      Caption         =   "Discard"
      Height          =   375
      Left            =   2100
      TabIndex        =   1
      Top             =   1260
      Width           =   1575
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "Save"
      Default         =   -1  'True
      Height          =   375
      Left            =   3780
      TabIndex        =   2
      Top             =   1260
      Width           =   1575
   End
   Begin VB.CommandButton cmdBrowse 
      Caption         =   "Browse..."
      Height          =   315
      Left            =   120
      TabIndex        =   0
      Top             =   780
      Width           =   1455
   End
   Begin VB.Label lblSaveDemo 
      Caption         =   "Save demo to..."
      Height          =   195
      Left            =   180
      TabIndex        =   3
      Top             =   180
      Width           =   1215
   End
End
Attribute VB_Name = "frmDemoSave"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Compare Binary
Option Base 0


' Some stuff to pass betweeen forms
Public DemoFileName As String
Public DemoExt As String


' Browse for a file to save to
Private Sub cmdBrowse_Click()

    Dim SaveFileName As String
    
    
    ' Display the dialog
    SaveFileName = modDialog.SaveFile(Me.hWnd, "Please enter the path and filename of the demo", "Demo files (*." & DemoExt & ")|*." & DemoExt & "|All files (*.*)|*.*", txtDemoFile.Text, cdlOFNHideReadOnly Or cdlOFNOverwritePrompt, 1)
    
    ' Update
    If SaveFileName <> "" Then
        SaveFileName = modUtil.RemoveExt(SaveFileName) & "." & DemoExt
        txtDemoFile.Text = SaveFileName
    End If

End Sub


' Discard the recorded demo
Private Sub cmdDiscard_Click()

    ' Delete the file
    Kill DemoFileName
    
    ' Hide me!
    Me.Hide

End Sub


' Save (rename) the demo file
Private Sub cmdSave_Click()

    Dim FileName As String
    
    
    ' Create filename
    FileName = modUtil.RemoveExt(txtDemoFile.Text) & "." & DemoExt
    
    ' Copy and kill it
    FileCopy DemoFileName, FileName
    Kill DemoFileName
    
    ' Hide me!
    Me.Hide

End Sub


' Set defaults on form activation
Private Sub Form_Activate()

    txtDemoFile.Text = Config.Root.Item("lastdir") & "\demo." & DemoExt

End Sub
