VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmSetup 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Program setup"
   ClientHeight    =   6195
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6075
   ControlBox      =   0   'False
   Icon            =   "frmSetup.frx":0000
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6195
   ScaleWidth      =   6075
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdRename 
      Caption         =   "Rename"
      Height          =   315
      Left            =   2040
      TabIndex        =   1
      Top             =   2220
      Width           =   1215
   End
   Begin VB.CommandButton cmdPath 
      Caption         =   "Path..."
      Height          =   315
      Left            =   3240
      TabIndex        =   5
      Top             =   4980
      Width           =   1275
   End
   Begin MSComctlLib.ListView lvwIWADs 
      Height          =   1755
      Left            =   180
      TabIndex        =   0
      Top             =   420
      Width           =   5715
      _ExtentX        =   10081
      _ExtentY        =   3096
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   0   'False
      HideSelection   =   0   'False
      HideColumnHeaders=   -1  'True
      FullRowSelect   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      Appearance      =   1
      NumItems        =   2
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Name"
         Object.Width           =   2646
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "File"
         Object.Width           =   7250
      EndProperty
   End
   Begin VB.CommandButton cmdEngineSettings 
      Caption         =   "Settings..."
      Height          =   315
      Left            =   4620
      TabIndex        =   6
      Top             =   4980
      Width           =   1275
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "Accept"
      Default         =   -1  'True
      Height          =   375
      Left            =   4320
      TabIndex        =   7
      Top             =   5640
      Width           =   1575
   End
   Begin VB.CommandButton cmdAdd 
      Caption         =   "Add"
      Height          =   315
      Left            =   4680
      TabIndex        =   3
      Top             =   2220
      Width           =   1215
   End
   Begin VB.CommandButton cmdRemove 
      Caption         =   "Remove"
      Height          =   315
      Left            =   3360
      TabIndex        =   2
      Top             =   2220
      Width           =   1215
   End
   Begin MSComctlLib.ListView lvwEngines 
      Height          =   1755
      Left            =   180
      TabIndex        =   4
      Top             =   3180
      Width           =   5715
      _ExtentX        =   10081
      _ExtentY        =   3096
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   0   'False
      HideSelection   =   0   'False
      HideColumnHeaders=   -1  'True
      FullRowSelect   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      Appearance      =   1
      NumItems        =   2
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Name"
         Object.Width           =   2646
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "File"
         Object.Width           =   7250
      EndProperty
   End
   Begin VB.Label lblEngines 
      Caption         =   "Engines"
      Height          =   195
      Left            =   240
      TabIndex        =   9
      Top             =   2940
      Width           =   675
   End
   Begin VB.Label lblIWADs 
      Caption         =   "Game WADs"
      Height          =   195
      Left            =   240
      TabIndex        =   8
      Top             =   180
      Width           =   1155
   End
End
Attribute VB_Name = "frmSetup"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Compare Binary
Option Base 0


' Only for first-run settings
Public FirstRun As Boolean


' Add an IWAD
Private Sub cmdAdd_Click()

    Dim IWADFile As String
    Dim IWADName As String
    
    Dim SimpleFile As String
    Dim DetectedName As String
    
        
    ' Let the user select a WAD file
    IWADFile = modDialog.OpenFile(Me.hWnd, "Please select a game WAD", "WAD files (*.wad)|*.wad|All files (*.*)|*.*", "", cdlOFNFileMustExist Or cdlOFNHideReadOnly)
    
    If IWADFile <> "" Then
    
        ' Check if it is indeed an IWAD
        Dim WadFile As New clsWad
        
        WadFile.OpenWad IWADFile
        If WadFile.WadType <> 0 Then
            MsgBox "Please select a game IWAD. The file you selected was a patch WAD.", vbOKOnly Or vbExclamation, MsgBoxTitle
            Set WadFile = Nothing
            Exit Sub
        End If
        
        ' Terminate the WAD class
        Set WadFile = Nothing
    
    
        ' Autodetect the name
        SimpleFile = LCase$(Mid$(IWADFile, InStrRev(IWADFile, "\") + 1))

        If DetectIWADs.Root.Exists(SimpleFile) = True Then
            DetectedName = DetectIWADs.Root.Item(SimpleFile)
        Else
            DetectedName = ""
        End If
        
        
        ' Ask for a name
        IWADName = InputBox("Please enter the formal name of the game WAD " & LCase$(IWADFile) & ".", "Enter a name", DetectedName)
        
        If IWADName <> "" Then
        
            ' Redimension the array
            ReDim Preserve IWADs(nIWADs) As IWadType
            nIWADs = nIWADs + 1
            
            ' Set the filename
            With IWADs(nIWADs - 1)
                .FileName = IWADFile
                .Name = IWADName
            End With
            
            ' Refill the lists
            Me.SetupLists
            
        End If
            
    End If
    
End Sub


' Display the engine settings dialog
Private Sub cmdEngineSettings_Click()

    frmEngineSettings.PassEngine lvwEngines.SelectedItem.Index - 1
    frmEngineSettings.Show 1

End Sub


' Hide this dialog
Private Sub cmdOK_Click()

    ' Check default IWAD
    If Config.Root.Item("iwad") > nIWADs - 1 Then Config.Root.Item("iwad") = nIWADs - 1
    
    ' Refill the main dialog's controls
    frmMain.SetupLists
    
    ' Hide me!
    Me.Hide

End Sub


' Fill the lists with their relevant info
Public Sub SetupLists()

    Dim A As Long
    
    Dim DefIWAD As Long
    Dim DefEngine As Long
    
    
    ' Remember default selected ones
    If Not (lvwIWADs.SelectedItem Is Nothing) Then DefIWAD = lvwIWADs.SelectedItem.Index Else DefIWAD = -1
    If Not (lvwEngines.SelectedItem Is Nothing) Then DefEngine = lvwEngines.SelectedItem.Index Else DefEngine = -1
    
    ' The list of IWADs
    lvwIWADs.ListItems.Clear
    If nIWADs > 0 Then
        For A = 0 To nIWADs - 1
            lvwIWADs.ListItems.Add , , IWADs(A).Name
            lvwIWADs.ListItems(A + 1).ListSubItems.Add , , IWADs(A).FileName
        Next A
        lvwIWADs.ListItems(1).Selected = True
    End If

    ' The list of engines
    lvwEngines.ListItems.Clear
    If nEngines > -1 Then
        For A = 0 To nEngines - 1
            lvwEngines.ListItems.Add , , Engines(A).Name
            lvwEngines.ListItems(A + 1).ListSubItems.Add , , Engines(A).ExecutablePath & "\"
        Next A
        lvwEngines.ListItems(1).Selected = True
    End If
    
    ' Put back the default selected items
    If DefIWAD > 0 And DefIWAD < lvwIWADs.ListItems.Count + 1 Then lvwIWADs.ListItems(DefIWAD).Selected = True
    If DefEngine > 0 And DefEngine < lvwEngines.ListItems.Count + 1 Then lvwEngines.ListItems(DefEngine).Selected = True
        
End Sub


' Browse for an engine's path
Private Sub cmdPath_Click()

    Dim Selected As Long
    Dim NewFolder As String
    
    
    ' Get the selected item
    Selected = lvwEngines.SelectedItem.Index - 1
    
    ' Browse for the directory
    NewFolder = modDialog.SelectFolder(Me.hWnd, "Please select the folder in which " & LCase$(Engines(Selected).Executable) & " resides.")
    
    ' Set the new folder
    If NewFolder <> "" Then
        
        Engines(Selected).ExecutablePath = NewFolder
        
        ' Refill the lists
        Me.SetupLists

    End If
    
End Sub


' Remove the IWAD from the list
Private Sub cmdRemove_Click()

    Dim A As Long
    Dim Selected As Long
    
    
    ' Exit if no item is selected
    If lvwIWADs.SelectedItem Is Nothing Then Exit Sub
    
    ' Get the selected item
    Selected = lvwIWADs.SelectedItem.Index - 1
    
    ' Remove the entry
    For A = Selected To nIWADs - 2
        IWADs(A) = IWADs(A + 1)
    Next A
    
    ' Redimension the array
    nIWADs = nIWADs - 1
    If nIWADs = 0 Then
        ReDim Preserve IWADs(0) As IWadType
    Else
        ReDim Preserve IWADs(nIWADs - 1) As IWadType
    End If
    
    ' Refill the lists
    Me.SetupLists

End Sub


' Rename an IWAD
Private Sub cmdRename_Click()

    Dim Selected As Long
    
    Dim IWADName As String
    Dim IWADFile As String
    
    
    ' Get the selected IWAD
    If lvwIWADs.SelectedItem Is Nothing Then Exit Sub
    Selected = lvwIWADs.SelectedItem.Index - 1
    
    ' Get the IWAD's filename
    IWADFile = IWADs(Selected).FileName
    
    ' Ask for the name
    IWADName = InputBox("Please enter the name of the game WAD " & UCase$(IWADFile) & ".", "Enter a name", IWADs(Selected).Name)
    
    
    ' Rename the IWAD if the user didn't press Cancel
    If IWADName <> "" Then
    
        IWADs(Selected).Name = IWADName
        
        ' Refresh the lists
        Me.SetupLists
        
    End If

End Sub


' Double clicking an engine edits it's settings
Private Sub lvwEngines_DblClick()

    cmdEngineSettings_Click

End Sub


' Double clicking an IWAD renames it
Private Sub lvwIWADs_DblClick()

    cmdRename_Click

End Sub
